stages:
  - build

build-server:
  stage: build
  image: haskell:8.8.3
  variables:
    STACK_ROOT: $CI_PROJECT_DIR/server/.stack-root
  cache:
    paths:
      - $CI_PROJECT_DIR/server/.stack-root
      - $CI_PROJECT_DIR/server/.stack-work
  script:
    - (cd server && stack build --pedantic --test --copy-bins)
    - (cd server && stack run typescript | diff --report-identical-files ../client/server.d.ts -)

build-client:
  image: node:12.18.3
  stage: build
  script:
    - (cd client && npm ci)
    - (cd client && npm run check)
    - (cd client && npm run build)
